> ## Documentation Index
> Fetch the complete documentation index at: https://uiform-codex-generated-frontend-snippets.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# List Tables

List tables available in the current environment.

```python Python theme={null}
tables = client.tables.list()
```

```typescript TypeScript theme={null}
const tables = await client.tables.list();
```

```go Go theme={null}
tables, err := client.Tables.List(ctx)
```

```java Java theme={null}
// List tables with the Retab Java client.
```

```bash cURL theme={null}
curl https://api.retab.com/v1/tables -H "Authorization: Bearer $RETAB_API_KEY"
```


## OpenAPI

````yaml GET /v1/tables
openapi: 3.1.0
info:
  title: FastAPI
  version: 0.1.0
servers:
  - url: https://api.retab.com
security: []
paths:
  /v1/tables:
    get:
      tags:
        - Tables
      summary: Table.List
      operationId: list_tables
      parameters:
        - in: query
          name: project_id
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Only return tables belonging to this project.
            title: Project Id
          required: false
          description: Only return tables belonging to this project.
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/WorkflowTableListResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - HTTPBearer: []
components:
  schemas:
    WorkflowTableListResponse:
      properties:
        tables:
          items:
            $ref: '#/components/schemas/WorkflowTable'
          type: array
          title: Tables
          default: []
      type: object
      title: WorkflowTableListResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
          default: []
      type: object
      title: HTTPValidationError
    WorkflowTable:
      properties:
        id:
          type: string
          title: Id
        name:
          type: string
          title: Name
        filename:
          type: string
          title: Filename
        project_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Project Id
          description: >-
            Project that owns this table. Null only on legacy rows that predate
            the project backfill.
        source_file_id:
          type: string
          title: Source File Id
          default: ''
        snapshot_file_id:
          type: string
          title: Snapshot File Id
          default: ''
        row_count:
          type: integer
          title: Row Count
        columns:
          items:
            $ref: '#/components/schemas/WorkflowTableColumn'
          type: array
          title: Columns
          default: []
        sample_rows:
          items:
            additionalProperties: true
            type: object
          type: array
          title: Sample Rows
          default: []
        metadata:
          additionalProperties: true
          type: object
          title: Metadata
          default: {}
        uploaded_by_user_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Uploaded By User Id
        created_at:
          type: string
          format: date-time
          title: Created At
        updated_at:
          type: string
          format: date-time
          title: Updated At
      type: object
      required:
        - filename
        - id
        - name
        - row_count
      title: WorkflowTable
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
        input:
          title: Input
          default: null
        ctx:
          type: object
          title: Context
          default: {}
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    WorkflowTableColumn:
      properties:
        name:
          type: string
          title: Name
        json_schema:
          additionalProperties: true
          type: object
          title: Json Schema
          default: {}
        sample_values:
          items:
            type: string
          type: array
          title: Sample Values
          default: []
        required:
          type: boolean
          title: Required
          default: false
        unique:
          type: boolean
          title: Unique
          default: false
      type: object
      required:
        - name
      title: WorkflowTableColumn
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

````